ArrayExpression (Groovy 5.0.6)
Description: declaration: package: org.codehaus.groovy.ast.expr, class: ArrayExpression

Package org.codehaus.groovy.ast.expr

# Class ArrayExpression

java.lang.Object
org.codehaus.groovy.ast.ASTNode
org.codehaus.groovy.ast.AnnotatedNode
org.codehaus.groovy.ast.expr.Expression
org.codehaus.groovy.ast.expr.ArrayExpression

All Implemented Interfaces:
  `GroovydocHolder<AnnotatedNode>`, `NodeMetaDataHandler`

public class ArrayExpression extends Expression
Represents an array object construction. One of:

- a fixed size array (e.g. `new String[3]` or `new Integer[2][3])`
- an array with an explicit initializer (e.g. `new String[]&#123; "foo", "bar" &#125;`)

- ## Field Summary

  ### Fields inherited from class org.codehaus.groovy.ast.expr.Expression

  `EMPTY_ARRAY`

  ### Fields inherited from interface groovy.lang.groovydoc.GroovydocHolder

  `DOC_COMMENT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ArrayExpression(ClassNode elementType, List<Expression> initExpressions)`
  Creates an array using an initializer (list of expressions corresponding to array elements).
  `ArrayExpression(ClassNode elementType, List<Expression> initExpressions, List<Expression> sizeExpressions)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addExpression(Expression initExpression)`
  Adds another element to the initializer expressions.
  `ClassNode`
  `getElementType()`
  `Expression`
  `getExpression(int i)`
  Gets a specific initializer expression.
  `List<Expression>`
  `getExpressions()`
  Gets the initializer expressions.
  `List<Expression>`
  `getSizeExpression()`
  `String`
  `getText()`
  `boolean`
  `hasInitializer()`
  `boolean`
  `isDynamic()`
  `String`
  `toString()`
  `Expression`
  `transformExpression(ExpressionTransformer transformer)`
  Transforms this expression and any nested expressions.
  `void`
  `visit(GroovyCodeVisitor visitor)`

  ### Methods inherited from class org.codehaus.groovy.ast.expr.Expression

  `getType, setType, transformExpressions, transformExpressions`

  ### Methods inherited from class org.codehaus.groovy.ast.AnnotatedNode

  `addAnnotation, addAnnotation, addAnnotations, getAnnotations, getAnnotations, getDeclaringClass, getGroovydoc, getInstance, hasNoRealSourcePosition, isSynthetic, setDeclaringClass, setHasNoRealSourcePosition, setSynthetic`

  ### Methods inherited from class org.codehaus.groovy.ast.ASTNode

  `copyNodeMetaData, getColumnNumber, getLastColumnNumber, getLastLineNumber, getLineNumber, getMetaDataMap, setColumnNumber, setLastColumnNumber, setLastLineNumber, setLineNumber, setMetaDataMap, setSourcePosition`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.codehaus.groovy.ast.NodeMetaDataHandler

  `copyNodeMetaData, getNodeMetaData, getNodeMetaData, getNodeMetaData, newMetaDataMap, putNodeMetaData, removeNodeMetaData, setNodeMetaData`

- ## Constructor Details

  - ### ArrayExpression

    public ArrayExpression(ClassNode elementType, List<Expression> initExpressions, List<Expression> sizeExpressions)

  - ### ArrayExpression

    public ArrayExpression(ClassNode elementType, List<Expression> initExpressions)
    Creates an array using an initializer (list of expressions corresponding to array elements).

- ## Method Details

  - ### transformExpression

    public Expression transformExpression(ExpressionTransformer transformer)
    Description copied from class: `Expression`
    Transforms this expression and any nested expressions.
    Specified by:
      `transformExpression` in class `Expression`

  - ### visit

    public void visit(GroovyCodeVisitor visitor)
    Overrides:
      `visit` in class `ASTNode`

  - ### getElementType

    public ClassNode getElementType()

  - ### getExpressions

    public List<Expression> getExpressions()
    Gets the initializer expressions.

  - ### getExpression

    public Expression getExpression(int i)
    Gets a specific initializer expression.

  - ### addExpression

    public void addExpression(Expression initExpression)
    Adds another element to the initializer expressions.

  - ### getSizeExpression

    public List<Expression> getSizeExpression()
    Returns:
      a list with elements corresponding to the array's dimensions

  - ### getText

    public String getText()
    Overrides:
      `getText` in class `ASTNode`

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`

  - ### isDynamic

    public boolean isDynamic()

  - ### hasInitializer

    public boolean hasInitializer()
    Returns:
      true if the array expression is defined by an explicit initializer